#!/bin/bash
# To install CentOS apache must be installed and server CentOS base
# root@raspberrypi:/ apt install apache2 -y
# root@raspberrypi:/ systemctl start httpd
# root@raspberrypi:/var/www/html# cp -a /root/rapidspace-autoinstall-os/centos-installer/ .
# root@raspberrypi:/var/www/html# chown pi: -R centos-installer/
# root@raspberrypi:/var/www/html# wget http://192.168.46.2/centos-installer/media.repo # just check

set -e

SCRIPT_DIR=$(realpath `dirname "$0"`)


. $SCRIPT_DIR/download_boot_systems.sh

download_debian_10_if_needed
download_sysrescuecd_if_needed
download_centos_8_if_needed

#UPDATE THOSE VARIABLES DEPENDING ON YOUR SITE
MY_IF_NAME=eth0
MY_IP_ADDR=192.168.46.2
DHCP_RANGE=192.168.46.100,192.168.46.200,255.255.255.0
ROUTER_ADDR=192.168.46.2
DNS_SERVER=8.8.8.8

common=console=ttyS1,57600

mac='
00:22:4d:d9:21:ec
7c:fe:90:43:50:10
7c:fe:90:43:13:4e
7c:fe:90:43:1a:90
'
i=0
hostname_list=(kuklen-tiogapass-000 kuklen-leopard-001 kuklen-leopard-002 kuklen-leopard-003)

(
#echo set timeout=0
echo if false
echo then true
for mac in $mac; do
  echo "elif [ \$net_default_mac = $mac ]"
  echo then set hostname=${hostname_list[$i]}
  i=`expr $i + 1`
done
cat <<EOF
else unset timeout
fi

menuentry 'Install Debian 10' {
  linux /debian-installer/amd64/linux vga=788 url=tftp://\$pxe_default_server/preseed_kuklen.cfg language=C country=SE keymap=us hostname=\$hostname domain= --- mitigations=off $common
  initrd /debian-installer/amd64/initrd.gz
}
menuentry 'Install CentOS' { 
  linux /centos-installer/images/pxeboot/vmlinuz checksum ip=dhcp inst.text inst.repo=http://\$pxe_default_server/centos-installer/  $common
  initrd /centos-installer/images/pxeboot/initrd.img
}
menuentry 'SystemRescueCd' {
  linux /sysresccd/sysresccd/boot/x86_64/vmlinuz archisobasedir=sysresccd archiso_http_srv=http://\$pxe_default_server:69/sysresccd/ checksum ip=dhcp $common
  initrd /sysresccd/sysresccd/boot/intel_ucode.img /sysresccd/sysresccd/boot/amd_ucode.img /sysresccd/sysresccd/boot/x86_64/sysresccd.img
}
menuentry 'Exit' {
  exit
}
EOF
) >debian-installer/amd64/grub/grub.cfg


for mac in $mac
do
  hostname=${hostname_list[$i]}
  mkdir -p $hostname
  if [[ "$hostname" =~ "leopard" ]]
  then
    cat > $hostname/interfaces <<EOF
# This file describes the network interfaces available on your system
# and how to activate them. For more information, see interfaces(5).

source /etc/network/interfaces.d/*

# The loopback network interface
auto lo
iface lo inet loopback

# The primary network interface
allow-hotplug ens1
iface ens1 inet dhcp
EOF
  else
    cat > $hostname/interfaces <<EOF
# This file describes the network interfaces available on your system
# and how to activate them. For more information, see interfaces(5).

source /etc/network/interfaces.d/*

# The loopback network interface
auto lo
iface lo inet loopback

# The RJ45 interface
allow-hotplug eno1
#iface eno1 inet dhcp
iface eno1 inet static
  address 192.168.46.$(( 50 + $i ))/24

# The SFP+ interface on the left
allow-hotplug ens9f1
iface ens9f1 inet dhcp
  dns-nameservers 8.8.8.8

#allow-hotplug ens9f0
##iface ens9f0 inet dhcp
#iface ens9f0 inet static
#  address 113.24.192.26/30
#  gateway 113.24.192.25
EOF
  fi
  i=`expr $i + 1`
done




exec dnsmasq -d --port=0 --log-dhcp \
  --interface=$MY_IF_NAME \
  --bind-interfaces \
  --except-interface=lo \
  --listen-address=$MY_IP_ADDR \
  --dhcp-range=$DHCP_RANGE \
  --dhcp-option=option:router,$ROUTER_ADDR \
  --dhcp-option=option:dns-server,$DNS_SERVER \
  --dhcp-boot=debian-installer/amd64/grubx64.efi \
  --enable-tftp --tftp-root=$(realpath `dirname "$0"`) \
  --conf-file=/dev/null \
  --dhcp-host=98:03:9b:9b:8a:47,10.0.45.101,1h \

