#!/bin/bash
set -e

SCRIPT_DIR=$(realpath `dirname "$0"`)


. $SCRIPT_DIR/download_boot_systems.sh

download_debian_10_if_needed

#UPDATE THOSE VARIABLES DEPENDING ON YOUR SITE
MY_IF_NAME=eth0
MY_IP_ADDR=192.168.46.2
DHCP_RANGE=192.168.46.100,192.168.46.200,255.255.255.0
ROUTER_ADDR=192.168.46.2
DNS_SERVER=8.8.8.8

common=console=ttyS1,57600

mac='
00:22:4d:da:ca:a8
00:22:4d:d9:0a:ab
'
i=0
hostname_list=(lille-edu-capri-002 lille-edu-tiogapass-001)

(
#echo set timeout=0
echo if false
echo then true
for mac in $mac; do
  echo "elif [ \$net_default_mac = $mac ]"
  echo then set hostname=${hostname_list[$i]}
  i=`expr $i + 1`
done
cat <<EOF
else unset timeout
fi

menuentry 'Install Debian 10' {
  linux /debian-installer/amd64/linux vga=788  language=C country=SE keymap=us  domain= --- mitigations=off $common
  initrd /debian-installer/amd64/initrd.gz
}

menuentry 'Exit' {
  exit
}
EOF
) >debian-installer/amd64/grub/grub.cfg



for mac in $mac
do
  hostname=${hostname_list[$i]}
  mkdir -p $hostname
  cat > $hostname/interfaces <<EOF
# This file describes the network interfaces available on your system
# and how to activate them. For more information, see interfaces(5).

source /etc/network/interfaces.d/*

# The loopback network interface
auto lo
iface lo inet loopback

# The RJ45 interface
allow-hotplug eno1
#iface eno1 inet dhcp
iface eno1 inet static
  address 192.168.46.$(( 50 + $i ))/24

# The SFP+ interface on the left
allow-hotplug ens9f1
iface ens9f1 inet dhcp
  dns-nameservers 8.8.8.8


EOF
  i=`expr $i + 1`
done




exec dnsmasq -d --port=0 --log-dhcp \
  --interface=$MY_IF_NAME \
  --bind-interfaces \
  --except-interface=lo \
  --listen-address=$MY_IP_ADDR \
  --dhcp-range=$DHCP_RANGE \
  --dhcp-option=option:router,$ROUTER_ADDR \
  --dhcp-option=option:dns-server,$DNS_SERVER \
  --dhcp-boot=debian-installer/amd64/grubx64.efi \
  --enable-tftp --tftp-root=$(realpath `dirname "$0"`) \
  --conf-file=/dev/null \
  --dhcp-host=98:03:9b:9b:8a:47,10.0.45.101,1h \
