#!/bin/bash
# To install CentOS apache must be installed and server CentOS base
# root@raspberrypi:/ apt install apache2 -y
# root@raspberrypi:/ systemctl start httpd
# root@raspberrypi:/var/www/html# cp -a /root/rapidspace-autoinstall-os/centos-installer/ .
# root@raspberrypi:/var/www/html# chown pi: -R centos-installer/
# root@raspberrypi:/var/www/html# wget http://192.168.46.2/centos-installer/media.repo # just check

set -e

SCRIPT_DIR=$(realpath `dirname "$0"`)


. $SCRIPT_DIR/download_boot_systems.sh

download_debian_10_if_needed
download_sysrescuecd_if_needed
download_centos_8_if_needed

#UPDATE THOSE VARIABLES DEPENDING ON YOUR SITE
MY_IF_NAME=ens9f1
MY_IP_ADDR=124.163.255.99
DHCP_RANGE=124.163.255.99,static,255.255.255.0
ROUTER_ADDR=124.163.255.97
DNS_SERVER=1.2.4.8

common=console=ttyS1,57600

mac='
b8:59:9f:07:84:bb
b8:59:9f:07:81:db
b8:59:9f:07:80:53
b8:59:9f:07:89:4b
b8:59:9f:07:81:f3
b8:59:9f:07:80:4b
b8:59:9f:07:82:ab
b8:59:9f:07:7e:23
b8:59:9f:07:80:73
b8:59:9f:07:7e:13
b8:59:9f:07:80:63
'
i=1
hostname_prefix=xinzhou-unicom-tiogapass-

(
#echo set timeout=0
echo if false
echo then true
for mac in $mac; do
  echo "elif [ \$net_default_mac = $mac ]"
  echo then set i=`printf %03u $i`
  i=`expr $i + 1`
done
cat <<EOF
else unset timeout
fi

menuentry 'Install Debian 10' {
  linux /debian-installer/amd64/linux vga=788 url=tftp://\$pxe_default_server/preseed_xinzhou_unicom.cfg language=C country=CN keymap=us hostname=${hostname_prefix}\$i domain= --- mitigations=off $common
  initrd /debian-installer/amd64/initrd.gz
}
menuentry 'Install CentOS' {
  linux /centos-installer/images/pxeboot/vmlinuz checksum ip=dhcp inst.text inst.repo=http://\$pxe_default_server/centos-installer/  $common
  initrd /centos-installer/images/pxeboot/initrd.img
}
menuentry 'SystemRescueCd' {
  linux /sysresccd/sysresccd/boot/x86_64/vmlinuz archisobasedir=sysresccd archiso_http_srv=http://\$pxe_default_server:69/sysresccd/ checksum ip=dhcp $common
  initrd /sysresccd/sysresccd/boot/intel_ucode.img /sysresccd/sysresccd/boot/amd_ucode.img /sysresccd/sysresccd/boot/x86_64/sysresccd.img
}
menuentry 'Exit' {
  exit
}
EOF
) >debian-installer/amd64/grub/grub.cfg


for mac in $mac
do
  hostname=${hostname_prefix}$(printf %03u $i)
  mkdir -p $hostname
  cat > $hostname/interfaces <<EOF
# This file describes the network interfaces available on your system
# and how to activate them. For more information, see interfaces(5).

source /etc/network/interfaces.d/*

# The loopback network interface
auto lo
iface lo inet loopback

# The primary network interface
allow-hotplug eno1
#iface eno1 inet dhcp
iface eno1 inet static
  address 192.168.46.$(( 50 + $i ))/24

allow-hotplug ens9f1
iface ens9f1 inet static
  address 124.163.255.$(( 98 + $i ))/27
  gateway 124.163.255.97
  dns-nameservers 1.2.4.8 223.5.5.5 223.6.6.6

#allow-hotplug ens9f0
##iface ens9f0 inet dhcp
#iface ens9f0 inet static
#  address 113.24.192.26/30
#  gateway 113.24.192.25
EOF
  i=`expr $i + 1`
done




exec dnsmasq -d --port=0 --log-dhcp \
  --interface=$MY_IF_NAME \
  --bind-interfaces \
  --except-interface=lo \
  --listen-address=$MY_IP_ADDR \
  --dhcp-range=$DHCP_RANGE \
  --dhcp-option=option:router,$ROUTER_ADDR \
  --dhcp-option=option:dns-server,$DNS_SERVER \
  --dhcp-boot=debian-installer/amd64/grubx64.efi \
  --enable-tftp --tftp-root=$(realpath `dirname "$0"`) \
  --conf-file=/dev/null \
  --dhcp-host=b8:59:9f:07:84:bb,124.163.255.99,1h \
  --dhcp-host=b8:59:9f:07:81:db,124.163.255.100,1h \
  --dhcp-host=b8:59:9f:07:80:53,124.163.255.101,1h \
  --dhcp-host=b8:59:9f:07:89:4b,124.163.255.102,1h \
  --dhcp-host=b8:59:9f:07:81:f3,124.163.255.103,1h \
  --dhcp-host=b8:59:9f:07:80:4b,124.163.255.104,1h \
  --dhcp-host=b8:59:9f:07:82:ab,124.163.255.105,1h \
  --dhcp-host=b8:59:9f:07:7e:23,124.163.255.106,1h \
  --dhcp-host=b8:59:9f:07:80:73,124.163.255.107,1h \
  --dhcp-host=b8:59:9f:07:7e:13,124.163.255.108,1h \
  --dhcp-host=b8:59:9f:07:80:63,124.163.255.109,1h \



